import es, gamethread, playerlib

### Start Config ###

mode = "abuse" # Modes are: "abuse", "change name" or "kick"

### End Config ###

es.ServerVar("UNA_version", "UNA_v2.0").makepublic()

abuse_messages = {5: "#lightgreenWARNING:#green You have joined without a name", 10: "#green[#lightgreenUNA#green]: You will be punished!", 15: "#green[#lightgreenUNA#green]: if you wish to stay on our server change your name", 20: "#green[#lightgreenUNA#green]: press esc", 25: "#green[#lightgreenUNA#green]: and then go to options", 30: "#green[#lightgreenUNA#green]: there is a box called NAME: put your name there", 35: "#green[#lightgreenUNA#green]: HURRY! Your punishment will begin in #lightgreen15 #greenseconds"}

def load():
	es.msg("#multi", "#green[#lightgreenUNA#green]: Loaded")

def unload():
	es.msg("#multi", "#green[#lightgreenUNA#green]: Unloaded")

def player_activate(event_var):
	if event_var["es_username"] == 'unnamed' and not event_var['es_steamid'] == 'BOT':
		abuse(event_var["userid"])
		
def abuse(userid, message_time = None):
	unnamed_player = playerlib.getPlayer(userid)
	if es.getplayername(userid) == "unnamed":
		if message_time == None:
			message_time = 0
		else:
			message_time += 1
		if message_time in abuse_messages:
			es.tell(userid, "#multi", abuse_messages[message_time])
		elif message_time == 50:
			if mode == "kick":
				unnamed_player.kick(reason = "Come back when you have a name!")
			elif mode == "change name":
				es.cexec(userid, "name I HAS A NAME NOW!!!")
		gamethread.delayedname(1, "abuse_%s" % userid, abuse, args=(userid, message_time))
	else:
		es.tell(userid, '#multi', "#greenThank you for changing your name.")

def player_say(event_var):
	if event_var["es_username"] == "unnamed" and not event_var['es_steamid'] == 'BOT':
		es.tell(event_var["userid"], '#multi', '#green Did I say you could talk?')
		es.server.queuecmd("est_slay %s" % event_var["userid"])

def player_changename(ev):
	if ev['oldname'] == 'unnamed':
		for delay in ['speed', 'burn', 'drunk', 'fade', 'shake', 'freeze', 'rocket', 'drunk']:
			gamethread.cancelDelayed(delay + '_%s'%ev['userid'])

def player_disconnect(ev):
	for delay in ['speed', 'burn', 'drunk', 'fade', 'shake', 'freeze', 'rocket', 'drunk']:
		gamethread.cancelDelayed(delay + '_%s'%ev['userid'])

def player_spawn(event_var):
	if event_var["es_username"] == "unnamed" and not event_var['es_steamid'] == 'BOT':
		if mode == "abuse":
			p = playerlib.getPlayer(event_var['userid'])
			es.tell(event_var["userid"], "#green if you forgot how to change your name, scroll up!")
			es.server.queuecmd("est_stripplayer %s" % event_var["userid"])
			es.server.queuecmd("est_drug %s 5" % event_var["userid"])
			gamethread.delayedname(3, 'speed_%s'%event_var['userid'], p.set, ('speed', 0.3))
			gamethread.delayedname(6, 'burn_%s'%event_var['userid'], es.server.queuecmd, "est_burn %s 4" % event_var["userid"])
			gamethread.delayedname(7, 'drunk_%s'%event_var['userid'], es.server.queuecmd, "est_drunk %s 10" % event_var["userid"])
			gamethread.delayedname(10, 'fade_%s'%event_var['userid'], es.server.queuecmd, "est_fade %s 0 1 5 255 0 0 150" % event_var["userid"])
			gamethread.delayedname(10, 'shake_%s'%event_var['userid'], es.server.queuecmd, "est_shake %s 10 1000 1000" % event_var["userid"])
			gamethread.delayed(10, es.server.queuecmd, "est_speed %s 1" % event_var["userid"])
			gamethread.delayedname(12, 'freeze_%s'%event_var['userid'], p.set, ('freeze', 1))
			gamethread.delayedname(18, 'rocket_%s'%event_var['userid'], es.server.queuecmd, "est_rocket %s" % event_var["userid"])
			gamethread.delayedname(5, 'drunk_%s'%event_var['userid'], es.server.queuecmd, "est_drunk %s 10" % event_var["userid"]
